﻿Imports BilderDAL
Imports Wd = Microsoft.Office.Interop.Word
Imports System.Windows.Forms

Public Class CtpBildAuswahl

    Private Sub CtpBildAuswahl_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim Liste = DAL.GetKategorien
        liKategorien.DisplayMember = "Kategorie"
        liKategorien.ValueMember = "ID"
        liKategorien.DataSource = Liste
    End Sub

    Private Sub liKategorien_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles liKategorien.SelectedIndexChanged
        Dim Liste = DAL.GetBilderByKatID(liKategorien.SelectedValue)
        liBilder.ValueMember = "BildID"
        liBilder.DisplayMember = "Titel"
        liBilder.DataSource = Liste
    End Sub

    Private Sub bnBildAbrufen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnBildAbrufen.Click
        'Dim BildPfad As String = DAL.GetBildPfad(liBilder.Text)
        Dim BildPfad As String = DAL.GetBildPfadByID(liBilder.SelectedValue)
        If BildPfad <> "" Then
            Try
                ' Bild einfügen
                Globals.ThisAddIn.Application.Selection.InlineShapes.AddPicture(FileName:=BildPfad, LinkToFile:=True, SaveWithDocument:=False)
                ' Beschriftung nach leerem Absatz einfügen
                Globals.ThisAddIn.Application.Selection.TypeParagraph()
                Globals.ThisAddIn.Application.Selection.InsertCaption(Label:="Abbildung", Title:=CType(liBilder.Text, Object), Position:=Wd.WdCaptionPosition.wdCaptionPositionBelow)
            Catch ex As SystemException
                MessageBox.Show("Bild konnte nicht geladen werden." & vbCrLf & ex.Message)
            End Try
        Else
            MessageBox.Show("Keinen Bildpfad erhalten!", "Seltsam, seltsam...")
        End If
    End Sub

    Private Sub liBilder_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles liBilder.SelectedIndexChanged
        If Not cbVorschauAus.Checked Then
            Dim BildPfad As String = DAL.GetBildPfadByID(liBilder.SelectedValue)
            pbVorschau.Image = System.Drawing.Image.FromFile(BildPfad)
            lbPicSize.Text = String.Format("{0}x{1}", pbVorschau.Image.Height, pbVorschau.Image.Width)
        End If
    End Sub
End Class
