﻿Imports System.Windows.Forms

Public Class ThisAddIn

    Private Sub ThisAddIn_Startup(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Startup
        ' Eintrag in Extras einrichten
        Try
            Dim Cb As Office.CommandBar = Me.Application.CommandBars.Item("Menu Bar")
            ' Vorsicht: Funktioniert nur mit deutschsprachigen Word
            Dim Cn As Office.CommandBarControl = Cb.Controls("Extras")
            Dim CbBtn As Office.CommandBarButton = Cb.Controls.Add(Type:=Office.MsoControlType.msoControlButton, Temporary:=True)
            With CbBtn
                .Caption = "Buchmakros"
                .Style = Microsoft.Office.Core.MsoButtonStyle.msoButtonIconAndCaption
                .Tag = "Buchmakros"
                .FaceId = 59
            End With
            AddHandler CbBtn.Click, AddressOf ShowBuchMakroForm
        Catch ex As SystemException
            MessageBox.Show("Eintrag in Symbolleiste konnte nicht angelegt werden!", ex.Message)
        End Try
    End Sub

    Sub ShowBuchMakroForm(ByVal Btn As Office.CommandBarButton, ByRef CancelDefault As Boolean)
        Try
            Dim Frm As New fmMain(Me.Application)
            ' Nicht Gebunden anzeigen
            Frm.Show()
        Catch ex As SystemException
            MessageBox.Show("Formular kann nicht angezeigt werden!", ex.Message)
        End Try
    End Sub

    Private Sub ThisAddIn_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown
        ' Eintrag aus Extras-Menü entfernen
        Dim Cb As Office.CommandBar = Me.Application.CommandBars.Item("Menu Bar")
        Try
            Dim Cn As Office.CommandBarControl = Cb.FindControl(Tag:="Buchmakros")
            Cn.Delete()
        Catch ex As SystemException
            ' Hier passiert nichts
        End Try
    End Sub

End Class
