﻿'-----------------------------------------------------------
' Office 2007-Programmierung, Microsoft Press
' Excel-Daten einer Arbeitsmappe über die Jet-Engine einlesen
'-----------------------------------------------------------

Imports System.Data.OleDb

Public Class Form1
    Private Cn As OleDbConnection
    Private Da As OleDbDataAdapter
    Private Ta As DataTable

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        '
    End Sub

    Private Sub bnRefresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnRefresh.Click
        Dim OleStCb As New OleDbConnectionStringBuilder
        OleStCb.Provider = "Microsoft.Jet.OleDb.4.0"
        OleStCb.DataSource = "Verkaufsdaten2008.xls"
        OleStCb.Add("Extended Properties", "Excel 8.0;HDR=Yes")
        Cn = New OleDbConnection(OleStCb.ConnectionString)
        Try
            Cn.Open()
            Da = New OleDbDataAdapter("Select * From [Verkauf2008$]", Cn)
            Ta = New DataTable()
            Da.Fill(Ta)
            DataGridView1.DataSource = Ta
        Catch ex As OleDbException
            MessageBox.Show("OleDbError: " & ex.Message, My.Application.Info.Title)
        Finally
            Cn.Close()
        End Try

    End Sub

    Private Sub bnUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnUpdate.Click
        Dim Anzahl As Integer = 0
        Dim Sql As String
        Dim Cmd As OleDbCommand
        Try
            Cn.Open()
            For Each Dr As DataRow In Ta.Rows
                If Dr.RowState = DataRowState.Modified Then
                    Sql = "UPDATE [Verkauf2008$] Set Q1=@Q1, Q2=@Q2, Q3=@Q3, Q4=@Q4 WHERE Filiale=@Filiale"
                    Cmd = Cn.CreateCommand
                    Cmd.CommandText = Sql
                    Cmd.Parameters.AddWithValue("@Q1", Dr.Item("Q1"))
                    Cmd.Parameters.AddWithValue("@Q2", Dr.Item("Q2"))
                    Cmd.Parameters.AddWithValue("@Q3", Dr.Item("Q3"))
                    Cmd.Parameters.AddWithValue("@Q4", Dr.Item("Q4"))
                    Cmd.Parameters.AddWithValue("@Filiale", Dr.Item("Filiale"))
                    Anzahl += Cmd.ExecuteNonQuery()
                End If
            Next
            MessageBox.Show(Anzahl & " Datensätze aktualisiert", My.Application.Info.Title)
        Catch ex As OleDbException
            MessageBox.Show("OleDb-Error: " & ex.Message, My.Application.Info.Title)
        Catch Ex As SystemException
            MessageBox.Show("Error: " & Ex.Message, My.Application.Info.Title)
        Finally
            Cn.Close()
        End Try

    End Sub
End Class
