' -----------------------------------------------------------
' Office 2007-Programmierung, Microsoft Press
' Zugriff auf Yahoo-Finanzservice
' -----------------------------------------------------------
Imports Ex = Microsoft.Office.Interop.Excel
Imports System.IO
Imports System.Text

Module Module1

    Sub Main()
        Dim ExApp As Ex.Application = New Ex.Application
        ExApp.Visible = True
        ExApp.Workbooks.Add()
        Dim FormatString As String = "&f=sl1d1c1&e=.csv"
        Dim AktienSymbol As String = "MSFT"
        Dim YahooURL As String = "http://quote.yahoo.com/d/quotes.csv?s=" & AktienSymbol & FormatString
        Dim Req As System.Net.HttpWebRequest
        Dim Res As System.Net.HttpWebResponse
        Try
            Req = System.Net.WebRequest.Create(YahooURL)
            Res = Req.GetResponse
            Using Sr As New System.IO.StreamReader(Res.GetResponseStream(), Encoding.Default)
                ExApp.Range("A1").Value = Sr.ReadLine()
            End Using
        Catch Ex As SystemException
            ExApp.Range("A1").Value = "Exception: " & Ex.Message
        End Try


    End Sub

End Module
