﻿Imports System.Runtime.InteropServices
Imports System.Windows.Forms
Imports System.Reflection

<ComVisible(True)> _
Public Class OutPropPage
    Implements Outlook.PropertyPage
    Dim bIsDirty As Boolean
    Dim PropPageSite As Outlook.PropertyPageSite

    Private Sub InitPropPageSite()
        Dim T As Type = GetType(System.Windows.Forms.Form)
        Dim AssName As String = T.Assembly.FullName.ToString()
        Dim oleObjectType As Type = _
            Type.GetType(Assembly.CreateQualifiedName _
                         (AssName, "System.Windows.Forms.UnsafeNativeMethods")) _
                         .GetNestedType("IOleObject")
        Dim mInfo As MethodInfo = oleObjectType.GetMethod("GetClientSite")
        PropPageSite = mInfo.Invoke(Me, Nothing)
    End Sub

    Public Sub Apply() Implements Microsoft.Office.Interop.Outlook.PropertyPage.Apply
        Try
            Dim FO As Outlook.Folder = Globals.ThisAddIn.Fo
            Dim Anzahl As Integer
            If FO.Items.Count > 5 Then
                Anzahl = 5
            Else
                Anzahl = FO.Items.Count
            End If
            ' Vertrauen wir einmal darauf, das die ersten 5 Items auch MailItems sind
            For i As Integer = 1 To Anzahl
                CType(FO.Items.Item(i), Outlook.MailItem).MarkAsTask(Outlook.OlMarkInterval.olMarkToday)
                CType(FO.Items.Item(i), Outlook.MailItem).Save()
            Next
            ' Dieser Aufruf ist natürlich überflüssig und dient nur Testzwecken
            MessageBox.Show("Einstellungen wurden übernommen!", My.Application.Info.Title)
        Catch Ex As COMException
            MessageBox.Show("COM-Error: " & Ex.Message)
        Catch ex As SystemException
            MessageBox.Show("System-Error: " & ex.Message)
        End Try
    End Sub

    Public ReadOnly Property Dirty() As Boolean Implements Microsoft.Office.Interop.Outlook.PropertyPage.Dirty
        Get
            Return bIsDirty
        End Get
    End Property

    <DispId(-518)> _
Public ReadOnly Property PageCaption() As String
        Get
            Return "Peters Outlook-Property Page"
        End Get
    End Property

    Private Sub UserControl_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        InitPropPageSite()
        lbAnzahlMails.Text = Globals.ThisAddIn.Fo.Items.Count
    End Sub

    Private Sub ckFarbigMarkieren_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ckFarbigMarkieren.CheckedChanged
        bIsDirty = True
        PropPageSite.OnStatusChange()
    End Sub

    Public Sub GetPageInfo(ByRef HelpFile As String, ByRef HelpContext As Integer) Implements Microsoft.Office.Interop.Outlook.PropertyPage.GetPageInfo
        ' Hier passiert nichts bzw.
        MessageBox.Show("Hilfe ist noch nicht implementiert, sorry!")
    End Sub
End Class
