﻿' -----------------------------------------------------------
' Office 2007-Programmierung, Microsoft Press
' -----------------------------------------------------------

Public Class Tabelle1
    <Cached()> Public DsBuecher As DataSet

    Private Sub Tabelle1_Startup(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Startup
        ' DsBuecher = InitDs()
        If Not Me.IsCached("DsBuecher") Then
            MessageBox.Show("DsBuecher ist nicht im Cache.", My.Application.Info.Title)
            DsBuecher = InitDs()
        End If
        If DsBuecher Is Nothing Then
            DsBuecher = InitDs()
        End If
        List1.AutoSetDataBoundColumnHeaders = True
        List1.DataSource = DsBuecher.Tables("Buecher")
        List1.ShowAutoFilter = False
        List1.ShowTotals = False

        DisplayTable(DsBuecher.Tables("Buecher"), Application.Range("A10"))
    End Sub

    Private Sub Tabelle1_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown
        ' Hier passiert nichts
    End Sub

    Sub DisplayTable(ByVal Ta As DataTable, ByVal R As Excel.Range)
        Dim ZeilenNr As Integer = 0
        For SpaltenNr As Integer = 0 To Ta.Columns.Count - 1
            R.Offset(RowOffset:=ZeilenNr, ColumnOffset:=SpaltenNr).Value = Ta.Columns(SpaltenNr).ColumnName
        Next
        ZeilenNr += 1
        For Each Zeile As DataRow In Ta.Rows
            For SpaltenNr As Integer = 0 To Ta.Columns.Count - 1
                R.Offset(RowOffset:=ZeilenNr, ColumnOffset:=SpaltenNr).Value = Zeile.Item(SpaltenNr)
            Next
            ZeilenNr += 1
        Next
    End Sub

    Function InitDs() As DataSet
        Dim Ds As New DataSet("Testdaten")
        Dim Ta As New DataTable("Buecher")
        Ta.Columns.Add("BuchNr", GetType(Integer))
        Ta.Columns.Add("Titel", GetType(String))
        Ta.Columns.Add("Autor", GetType(String))
        Dim Zeile As DataRow = Ta.NewRow()
        Zeile.ItemArray = New Object() {1000, "Alles über VSTO", "Monadjemi"}
        Ta.Rows.Add(Zeile)
        Zeile = Ta.NewRow()
        Zeile.ItemArray = New Object() {1001, "XML gekonnt und clever", "Dr. Pfeifer"}
        Ta.Rows.Add(Zeile)
        Ds.Tables.Add(Ta)
        Return Ds
    End Function
End Class
