Public Class usrKreditrechner

    Dim tb As Kreditrechner.Tabelle1

    Private Sub Kreditrechner_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        tb = Kreditrechner.Globals.Tabelle1
        grpKreditsumme.Visible = True
        grpLaufzeit.Visible = False
        grpTilgungssatz.Visible = False
        grpExport.Visible = False

        grpLaufzeit.Left = grpKreditsumme.Left
        grpTilgungssatz.Left = grpKreditsumme.Left
        grpExport.Left = grpKreditsumme.Left
    End Sub

    Private Sub LinkLabel1_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles LinkLabel1.LinkClicked
        Process.Start("http://de.wikipedia.org/wiki/Kredit")
    End Sub

    Private Sub btnNext1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNext1.Click
        tb.Kreditsumme.Value2 = txtKreditsumme.Text
        tb.Laufzeit.Select()
    End Sub

    Private Sub Laufzeit(ByVal sender As Object, ByVal e As System.EventArgs) Handles opt5.Click, opt10.Click, opt15.Click
        Dim opt As RadioButton = CType(sender, RadioButton)
        tb.Laufzeit.Value2 = opt.Text.Trim.Split(" "c)(0)
    End Sub

    Private Sub grpKreditsumme_VisibleChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles grpKreditsumme.VisibleChanged
        txtKreditsumme.Text = tb.Kreditsumme.Value.ToString
    End Sub

    Private Sub btnNext2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNext2.Click
        tb.Tilgungssatz.Select()
    End Sub

    Private Sub ListBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstTilgung.SelectedIndexChanged
        tb.Tilgungssatz.Value2 = lstTilgung.SelectedItem
    End Sub

    Private Sub btnBack2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBack2.Click
        tb.Kreditsumme.Select()
    End Sub

    Private Sub btnNext3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNext3.Click
        tb.Belastung.Select()
    End Sub

    Private Sub btBack3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btBack3.Click
        tb.Laufzeit.Select()
    End Sub

    Private Sub btnExport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExport.Click
        Dim map As Excel.XmlMap = Kreditrechner.Globals.ThisWorkbook.XmlMaps(1)

        'ungeprft
        'map.Export(xlWb.Path & "\data.xml", True)

        'geprft
        Dim strDummy As String = ""
        Dim result As Excel.XlXmlExportResult
        Kreditrechner.Globals.ThisWorkbook.Application.DisplayAlerts = False
        map.ShowImportExportValidationErrors = True
        result = map.ExportXml(strDummy)
        If result = Excel.XlXmlExportResult.xlXmlExportSuccess Then
            map.Export(Globals.ThisWorkbook.Path & "\data.xml", True)
            MsgBox("Daten exportiert.")
        Else
            MsgBox("Validierung fehlgeschlagen.")
        End If
        Kreditrechner.Globals.ThisWorkbook.Application.DisplayAlerts = True

    End Sub

    Private Sub btnBack4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBack4.Click
        tb.Tilgungssatz.Select()
    End Sub

    Private Sub txtKreditsumme_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtKreditsumme.TextChanged
        If Not IsNumeric(txtKreditsumme.Text) Then
            ErrorProvider1.SetError(txtKreditsumme, "Nicht numerisch!")
            btnNext1.Enabled = False
        Else
            ErrorProvider1.SetError(txtKreditsumme, "")
            btnNext1.Enabled = True
        End If
    End Sub

End Class
