﻿Imports Excel = Microsoft.Office.Tools.Excel

Public Class ThisWorkbook
    Private WithEvents actPreisKürzen As Excel.Action
    Private WithEvents actPreisWeiten As Excel.Action
    Private WithEvents actPreisAbnähen As Excel.Action
    Private WithEvents actPreisFüttern As Excel.Action
    Dim apc As ActionsPaneControl1

    Private Sub ThisWorkbook_Startup(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Startup
        Dim stgPreis As Excel.SmartTag
        stgPreis = New Excel.SmartTag("urn:ep:devBook#Preis", "Preis")
        Dim astrTerms() As String = {"Jacke", "Hose", "Mantel"}
        stgPreis.Terms.AddRange(astrTerms)
        actPreisKürzen = New Excel.Action("Kürzen")
        actPreisWeiten = New Excel.Action("Weiten")
        actPreisAbnähen = New Excel.Action("Abnähen")
        actPreisFüttern = New Excel.Action("Füttern")
        stgPreis.Actions = New Excel.Action() {actPreisKürzen, actPreisWeiten, actPreisAbnähen, actPreisFüttern}
        documentSmartTags.Globals.ThisWorkbook.VstoSmartTags.Add(stgPreis)
    End Sub

    Private Sub ThisWorkbook_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown

    End Sub

    Private Sub actPreisAbnähen_Click(ByVal sender As Object, ByVal e As Microsoft.Office.Tools.Excel.ActionEventArgs) Handles actPreisAbnähen.Click
        Dim act As Microsoft.Office.Tools.Excel.Action = CType(sender, Microsoft.Office.Tools.Excel.Action)
        If apc Is Nothing Then
            apc = New ActionsPaneControl1
            documentSmartTags.Globals.ThisWorkbook.ActionsPane.Controls.Add(apc)
        End If
        apc.lblProdukt.Text = act.Caption & " - " & e.Text
        apc.lblPreis.Text = Format(5.99, "Currency")
        documentSmartTags.Globals.ThisWorkbook.Application.CommandBars("Task Pane").Visible = True
        documentSmartTags.Globals.ThisWorkbook.ActionsPane.Show()
    End Sub

    Private Sub actPreisFüttern_Click(ByVal sender As Object, ByVal e As Microsoft.Office.Tools.Excel.ActionEventArgs) Handles actPreisFüttern.Click
        Dim act As Microsoft.Office.Tools.Excel.Action = CType(sender, Microsoft.Office.Tools.Excel.Action)
        If apc Is Nothing Then
            apc = New ActionsPaneControl1
            documentSmartTags.Globals.ThisWorkbook.ActionsPane.Controls.Add(apc)
        End If
        apc.lblProdukt.Text = act.Caption & " - " & e.Text
        Select Case e.Text
            Case "Mantel"
                apc.lblPreis.Text = Format(16.99, "Currency")
            Case Else
                apc.lblPreis.Text = Format(9.99, "Currency")
        End Select
        documentSmartTags.Globals.ThisWorkbook.Application.CommandBars("Task Pane").Visible = True
        documentSmartTags.Globals.ThisWorkbook.ActionsPane.Show()
    End Sub

    Private Sub actPreisKürzen_Click(ByVal sender As Object, ByVal e As Microsoft.Office.Tools.Excel.ActionEventArgs) Handles actPreisKürzen.Click
        Dim act As Microsoft.Office.Tools.Excel.Action = CType(sender, Microsoft.Office.Tools.Excel.Action)
        If apc Is Nothing Then
            apc = New ActionsPaneControl1
            documentSmartTags.Globals.ThisWorkbook.ActionsPane.Controls.Add(apc)
        End If
        apc.lblProdukt.Text = act.Caption & " - " & e.Text
        Select Case e.Text
            Case "Mantel"
                apc.lblPreis.Text = Format(4.99, "Currency")
            Case Else
                apc.lblPreis.Text = Format(3.99, "Currency")
        End Select
        documentSmartTags.Globals.ThisWorkbook.Application.CommandBars("Task Pane").Visible = True
        documentSmartTags.Globals.ThisWorkbook.ActionsPane.Show()
    End Sub

    Private Sub actPreisWeiten_Click(ByVal sender As Object, ByVal e As Microsoft.Office.Tools.Excel.ActionEventArgs) Handles actPreisWeiten.Click
        Dim act As Microsoft.Office.Tools.Excel.Action = CType(sender, Microsoft.Office.Tools.Excel.Action)
        If apc Is Nothing Then
            apc = New ActionsPaneControl1
            documentSmartTags.Globals.ThisWorkbook.ActionsPane.Controls.Add(apc)
        End If
        apc.lblProdukt.Text = act.Caption & " - " & e.Text
        apc.lblPreis.Text = Format(7.99, "Currency")
        documentSmartTags.Globals.ThisWorkbook.Application.CommandBars("Task Pane").Visible = True
        documentSmartTags.Globals.ThisWorkbook.ActionsPane.Show()
    End Sub

End Class

