﻿Public Class rangeProps
    Private mActiveCell As Excel.Range

    Public Property activeCell() As Excel.Range
        Get
            Return mActiveCell
        End Get
        Set(ByVal value As Excel.Range)
            mActiveCell = value
        End Set
    End Property

    Private Sub rangeProps_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Activated
        lblActiveCell.Text = mActiveCell.Address(External:=True)
        lblMap.Text = ""
        lblNamespace.Text = ""
        lblRepeating.Text = ""
        lblXPath.Text = ""
        Try
            Dim map As Excel.XmlMap = mActiveCell.XPath.Map
            lblMap.Text = map.Name
            lblNamespace.Text = map.RootElementNamespace.Uri
            lblRepeating.Text = mActiveCell.XPath.Repeating.ToString
            lblXPath.Text = mActiveCell.XPath.Value
        Catch ex As Exception

        End Try
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Try
            Clipboard.SetText(mActiveCell.XPath.Value)
        Catch ex As Exception
            Clipboard.SetText("")
        End Try
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Try
            Clipboard.SetText(mActiveCell.Value(Excel.XlRangeValueDataType.xlRangeValueXMLSpreadsheet).ToString)
        Catch ex As Exception
            Clipboard.SetText("")
        End Try
    End Sub

End Class