﻿Public Class ActionsPaneControl1
    Delegate Sub setLabelTextCallback(ByVal strMessage As String)

    Private Sub btnLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoad.Click
        'direkte Aufruf zum Testen
        'Try
        '    asynchImport.Globals.ThisWorkbook.XmlMaps(1).ImportXml(GetData)
        'Catch ex As Exception
        '    lblMessage.Text = ex.Message
        'End Try

        'asynchroner Aufruf
        If Not BackgroundWorker1.IsBusy Then
            lblMessage.Text = "Connecting..."
            BackgroundWorker1.RunWorkerAsync()
        End If
    End Sub

    Private Sub BackgroundWorker1_DoWork(ByVal sender As Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        e.Result = GetData()
    End Sub

    Private Sub BackgroundWorker1_RunWorkerCompleted(ByVal sender As Object, ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles BackgroundWorker1.RunWorkerCompleted
        If Not e.Result = "" Then
            asynchImport.Globals.ThisWorkbook.XmlMaps(1).ImportXml(e.Result)
            setLabelText("Done")
        End If
    End Sub

    Private Sub ActionsPaneControl1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        lblMessage.Text = ""
    End Sub

    Private Function GetData() As String
        Dim con As New SqlClient.SqlConnection
        'con.ConnectionString = My.Settings.NorthwindConnectionString
        con.ConnectionString = My.Settings.NorthwindOnVSOFFICE2007
        Dim selComm As New SqlClient.SqlCommand
        selComm.CommandText = "Select * from Products"
        selComm.Connection = con
        Dim adapter As New SqlClient.SqlDataAdapter
        adapter.SelectCommand = selComm
        Dim dataset As New NewDataSet 'dieses DataSet wird automatisch auf Grund der Map in der Arbeitsmappe angelegt
        dataset.DataSetName = "dataroot" 'dieser Name entsteht beim Export aus Access
        Try
            con.Open()
            adapter.Fill(dataset, "dbo_products")
            con.Close()
            Return dataset.GetXml
        Catch ex As Exception
            setLabelText(ex.Message)
            Return ""
        End Try
    End Function

    Private Sub setLabelText(ByVal strMessage As String)
        If lblMessage.InvokeRequired Then
            Dim del As New setLabelTextCallback(AddressOf setLabelText)
            Me.Invoke(del, New Object() {strMessage})
        Else
            lblMessage.Text = strMessage
        End If
    End Sub

    Private Sub lblMessage_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles lblMessage.DoubleClick
        MsgBox(lblMessage.Text)
    End Sub
End Class
