﻿Public Class changeCustomXml

    Private mActivedocument As Word.Document
    Private custom As Office.CustomXMLPart
    Private nd As Office.CustomXMLNode

    Public WriteOnly Property activeDocument() As Word.Document
        Set(ByVal value As Word.Document)
            mActivedocument = value
        End Set
    End Property

    Private Sub btnChange_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnChange.Click
        Try
            If nd.NamespaceURI = "http://schemas.openxmlformats.org/officeDocument/2006/extended-properties" Or _
                nd.NamespaceURI = "http://schemas.openxmlformats.org/package/2006/metadata/core-properties" Or _
                nd.NamespaceURI = "http://purl.org/dc/elements/1.1/" Or _
                nd.NamespaceURI = "http://schemas.microsoft.com/office/2006/coverPageProps" Then
                Dim xml As New Xml.XmlDocument
                xml.LoadXml(txtXML.Text)
                nd.Text = xml.InnerText
            Else
                custom.DocumentElement.ReplaceChildSubtree(txtXML.Text, nd)
            End If
            txtXML.Text = nd.XML
            Me.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

    Private Sub changeCustomXml_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            Dim customDummy As Office.CustomXMLPart
            ComboBox1.Items.Clear()
            For Each customDummy In mActivedocument.CustomXMLParts
                ComboBox1.Items.Add(customDummy.NamespaceURI)
            Next
            If ComboBox1.Items.Count > 0 Then
                ComboBox1.SelectedIndex = 0
            End If
        Catch ex As Exception

        End Try
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        Try
            custom = mActivedocument.CustomXMLParts(ComboBox1.SelectedIndex + 1)
            Dim ndDummy As Office.CustomXMLNode
            ListBox1.Items.Clear()
            For Each ndDummy In custom.DocumentElement.ChildNodes
                If ndDummy.NodeType = Microsoft.Office.Core.MsoCustomXMLNodeType.msoCustomXMLNodeElement Then
                    ListBox1.Items.Add(ndDummy.XPath)
                End If
            Next
            If ListBox1.Items.Count > 0 Then
                ListBox1.SelectedIndex = 0
            End If
        Catch ex As Exception

        End Try

    End Sub

    Private Sub ListBox1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListBox1.SelectedIndexChanged
        nd = custom.DocumentElement.SelectSingleNode(ListBox1.SelectedItem.ToString)
        txtXML.Text = nd.XML
    End Sub
End Class