﻿Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.ComponentModel
Imports System.Xml

' Um das Aufrufen dieses Webdiensts aus einem Skript mit ASP.NET-AJAX zuzulassen, heben Sie die Auskommentierung der folgenden Zeile auf.
' <System.Web.Script.Services.ScriptService()> _
<System.Web.Services.WebService(Namespace:="urn:Microsoft.Search")> _
<System.Web.Services.WebServiceBinding(ConformsTo:=WsiProfiles.BasicProfile1_1)> _
<ToolboxItem(False)> _
Public Class researchService
    Inherits System.Web.Services.WebService

    <WebMethod()> Public Function Registration(ByVal registrationXml As String) As String
        Dim xmlDoc As New System.Xml.XmlDocument
        Dim path As String = Server.MapPath("~/App_Data")
        xmlDoc.Load(path & "\registrationResponse.xml")
        Return xmlDoc.InnerXml
    End Function

    <WebMethod()> Public Function Query(ByVal queryXml As String) As String
        Dim ws As New localhost.Products
        Dim strQuery As String

        Try
            Dim xmlQueryDoc As New XmlDocument
            xmlQueryDoc.LoadXml(queryXml)
            Dim nsmgrQuery As New XmlNamespaceManager(xmlQueryDoc.NameTable)
            nsmgrQuery.AddNamespace("q", "urn:Microsoft.Search.Query")
            strQuery = xmlQueryDoc.SelectSingleNode("//q:QueryText", nsmgrQuery).InnerText
        Catch
            strQuery = "Dairy Products"
        End Try

        Dim xmlDataDoc As New XmlDocument
        xmlDataDoc.LoadXml(ws.GetActualData.xmlInfo.GetXml)
        Dim nsmgrData As New XmlNamespaceManager(xmlDataDoc.NameTable)
        nsmgrData.AddNamespace("data", "http://dev2007/webservice/dsProducts.xsd")
        Dim ndsFound As XmlNodeList = xmlDataDoc.SelectNodes("*//data:MyProducts[data:CategoryName='" & _
           strQuery & "']", nsmgrData)

        Dim xmlResponseDoc As New XmlDocument
        Dim path As String = Server.MapPath("~/App_Data")
        xmlResponseDoc.Load(path & "\queryResponse.xml")
        Dim ndContent As XmlNode
        Dim nsmgrContent As New XmlNamespaceManager(xmlResponseDoc.NameTable)
        nsmgrContent.AddNamespace("cont", "urn:Microsoft.Search.Response.Content")
        ndContent = xmlResponseDoc.SelectSingleNode("*//cont:Content", nsmgrContent)

        Try
            For Each ndCategory As XmlNode In ndsFound
                Dim ndP As XmlNode = xmlResponseDoc.CreateNode(XmlNodeType.Element, "P", _
                   "urn:Microsoft.Search.Response.Content")
                ndP.InnerText = ndCategory.SelectSingleNode("data:ProductName", _
                   nsmgrData).InnerText
                Dim ndActions As XmlNode = xmlResponseDoc.CreateNode(XmlNodeType.Element, _
                   "Actions", "urn:Microsoft.Search.Response.Content")
                Dim ndInsert As XmlNode = xmlResponseDoc.CreateNode(XmlNodeType.Element, _
                   "Insert", "urn:Microsoft.Search.Response.Content")
                ndActions.AppendChild(ndInsert)
                Dim ndCopy As XmlNode = xmlResponseDoc.CreateNode(XmlNodeType.Element, "Copy", _
                   "urn:Microsoft.Search.Response.Content")
                ndActions.AppendChild(ndCopy)
                ndP.AppendChild(ndActions)
                ndContent.AppendChild(ndP)
            Next
            Return xmlResponseDoc.InnerXml
        Catch ex As Exception
            Return xmlResponseDoc.InnerXml
        End Try
    End Function

End Class