﻿Public Class UserControl1

    Dim ds As Data.DataSet

    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click
        Try
            ds = Nothing
            lblResults.Text = "Gefunden: 0"
            btnInsert.Enabled = False

            Dim ws As New officeserver.QueryService
            Dim credentials = New System.Net.NetworkCredential("Dev2007", "p@ssw0rd", "EP")
            ws.Credentials = credentials

            Dim xmlQueryDoc As New Xml.XmlDocument
            xmlQueryDoc.LoadXml(My.Resources.queryFile)
            Dim nsmgrQuery As New Xml.XmlNamespaceManager(xmlQueryDoc.NameTable)
            nsmgrQuery.AddNamespace("user", "urn:Microsoft.Search.Query")
            Dim nd As Xml.XmlNode
            nd = xmlQueryDoc.SelectSingleNode("user:QueryPacket/user:Query/user:Context/user:QueryText", nsmgrQuery)
            If txtQueryText.Text.Trim.Length > 0 Then
                nd.InnerText = txtQueryText.Text
            Else
                nd.InnerText = "Entwicklerhandbuch"
            End If

            ds = ws.QueryEx(xmlQueryDoc.OuterXml)

            Dim xmlResultsDoc As New Xml.XmlDocument
            xmlResultsDoc.LoadXml(ds.GetXml)
            Dim ndl As Xml.XmlNodeList = xmlResultsDoc.SelectNodes("Results/RelevantResults")
            If ndl.Count > 0 Then
                btnInsert.Enabled = True
                lblResults.Text = "Gefunden: " & ndl.Count
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub btnInsert_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInsert.Click
        If SharePointSearch.Globals.ThisAddIn.Application.Documents.Count > 0 Then
            Dim doc As Word.Document
            doc = SharePointSearch.Globals.ThisAddIn.Application.ActiveDocument
            If Not ds Is Nothing Then
                Dim xmlDoc As New Xml.XmlDocument
                xmlDoc.LoadXml(ds.GetXml)
                Dim xmlTrans As New Xml.Xsl.XslCompiledTransform
                Dim xmlStyleSheet As New Xml.XmlDocument
                xmlStyleSheet.LoadXml(My.Resources.transformResults)
                Dim myReader As Xml.XmlReader = Xml.XmlReader.Create(New System.IO.StringReader(xmlStyleSheet.OuterXml))
                xmlTrans.Load(myReader)
                Dim b As New StringBuilder
                Dim myWriter As Xml.XmlWriter = Xml.XmlWriter.Create(b)
                xmlTrans.Transform(xmlDoc, myWriter)
                doc.Application.Selection.Range.InsertXML(b.ToString)
            End If
        End If
    End Sub

    Private Sub UserControl1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        lblResults.Text = ""
        btnInsert.Enabled = False
    End Sub
End Class
