﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="xml"/>
  <xsl:template match="/">
    <w:wordDocument
       xmlns:w="http://schemas.microsoft.com/office/word/2003/wordml"
       xml:space="preserve">
      <w:body>
      <w:tbl>
          <w:tblPr>
            <w:tblW w:w="0" w:type="auto" />
            <w:tblBorders />
            <w:tblLook w:val="04A0" />
          </w:tblPr>
          <w:tblGrid />
          <w:tr>
             <w:tc>
              <w:tcPr />
              <w:p>
                <w:pPr />
                  <w:r>
                  <w:rPr />
                  <w:t>Autor</w:t>
                </w:r>
              </w:p>
            </w:tc>
            <w:tc>
              <w:tcPr />
              <w:p>
                <w:pPr />
                  <w:r>
                  <w:rPr />
                  <w:t>Titel</w:t>
                </w:r>
              </w:p>
            </w:tc>
            <w:tc>
              <w:tcPr />
              <w:p>
                <w:pPr />
                  <w:r>
                  <w:rPr />
                  <w:t>Pfad</w:t>
                </w:r>
              </w:p>
            </w:tc>
          </w:tr>
          <xsl:for-each select="Results/RelevantResults">
            <w:tr>
              <w:tc>
                <w:tcPr />
                <w:p>
                  <w:pPr />
                    <w:r>
                    <w:rPr />
                    <w:t><xsl:value-of select="Author"/></w:t>
                  </w:r>
                </w:p>
              </w:tc>
              <w:tc>
                <w:tcPr />
                <w:p>
                  <w:pPr />
                    <w:r>
                    <w:rPr />
                    <w:t><xsl:value-of select="Title"/></w:t>
                  </w:r>
                </w:p>
              </w:tc>
              <w:tc>
                <w:tcPr />
                <w:p>
                  <w:pPr />
                    <w:r>
                    <w:rPr />
                    <w:t><xsl:value-of select="Path"/></w:t>
                  </w:r>
                </w:p>
              </w:tc>
            </w:tr>
          </xsl:for-each>
        </w:tbl>
      </w:body>
    </w:wordDocument>
  </xsl:template>
</xsl:stylesheet>
