﻿
Public Class Tabelle1

    Private Sub Tabelle1_Startup(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Startup
        List1.ListColumns("Betrag").TotalsCalculation = Excel.XlTotalsCalculation.xlTotalsCalculationSum
        List1.ListColumns("Betrag").Range.NumberFormatLocal = "#.##0,00 €"
        List1.ListColumns("Netto").Range.NumberFormatLocal = "#.##0,00 €"
        List1.ListColumns("Netto").Range.FormulaLocal = "=A2/(100+B2)*B2"
    End Sub

    Private Sub Tabelle1_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown

    End Sub

    Private Sub bnKonten_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnKonten.Click
        Dim Konten As New Dictionary(Of String, Double)
        Dim KontoOffset As Integer = List1.ListColumns("Konto").Range.Column
        Dim BetragOffset As Integer = List1.ListColumns("Betrag").Range.Column
        Dim ZeilenNr As Integer = 0
        For ZeilenNr = 2 To List1.Range.Rows.Count - 1
            Dim KontoName As String = CType(List1.Range.Item(RowIndex:=ZeilenNr, ColumnIndex:=KontoOffset).Value2, String)
            ' Gibt es überhaupt ein Konto?
            If KontoName Is Nothing Then
                Exit Sub
            End If
            Dim Betrag As String = List1.Range.Item(RowIndex:=ZeilenNr, ColumnIndex:=BetragOffset).Value2
            If Not Konten.ContainsKey(KontoName) Then
                Konten.Add(KontoName, Betrag)
            Else
                Konten.Item(KontoName) += Betrag
            End If
        Next
        ' Jetzt Kontenzusammenfassung im Tabellenblatt ausgeben
        Dim RKonten As Excel.Range = Me.Range("H2")
        RKonten.Offset(RowOffset:=0, ColumnOffset:=0).Value2 = "Konto"
        RKonten.Offset(RowOffset:=0, ColumnOffset:=1).Value2 = "Betrag"
        ZeilenNr = 1
        For Each K As String In Konten.Keys
            RKonten.Offset(RowOffset:=ZeilenNr, ColumnOffset:=0).Value2 = K
            RKonten.Offset(RowOffset:=ZeilenNr, ColumnOffset:=1).Value2 = Konten.Item(K)
            RKonten.Offset(RowOffset:=ZeilenNr, ColumnOffset:=1).NumberFormatLocal = "#.##0,00 €"
            ZeilenNr += 1
        Next
        ' Jetzt ein Chart anlegen
        Dim PositionLinks As Single = List1.Range.Left + List1.Range.Width + 20
        Dim PositionOben As Single = RKonten.Offset(RowOffset:=ZeilenNr + 2).Top
        ' Gibt es das Chart schon?
        Dim Cho As Excel.ChartObject
        If Globals.Tabelle1.ChartObjects.Count = 0 Then
            Cho = Globals.Tabelle1.ChartObjects.Add(PositionLinks, PositionOben, 300, 240)
        Else
            Cho = Globals.Tabelle1.ChartObjects(1)
        End If
        Cho.Chart.ChartType = Excel.XlChartType.xl3DPie
        Cho.Chart.HasTitle = True
        Cho.Chart.ChartTitle.Text = "Kontenzusammenfassung"
        Dim RKontenBereich As Excel.Range = RKonten.Resize(RowSize:=ZeilenNr, ColumnSize:=2)
        Cho.Chart.SetSourceData(RKontenBereich)

    End Sub
End Class
