﻿' -----------------------------------------------------------
' Office 2007-Programmierung, Microsoft Press
' -----------------------------------------------------------
Imports System.Runtime.InteropServices
Imports Microsoft.Win32

<ClassInterface(ClassInterfaceType.AutoDual), ProgId("ExcelNET.Functions")> _
Public Class Functions

    Public Function NetAdd(ByVal n1 As Double, ByVal n2 As Double) As Double
        Return n1 + n2
    End Function

    Public Function NetSub(ByVal n1 As Double, ByVal n2 As Double) As Double
        Return n1 - n2
    End Function

#Region "Nicht sichtbare Methoden"

    <ComVisible(False)> _
        Public Overrides Function ToString() As String
        Return "Peters Excel.NET-Funktionen"
    End Function

    <ComVisible(False)> _
        Public Overrides Function GetHashCode() As Integer
        Return MyBase.GetHashCode
    End Function

    <ComVisible(False)> _
        Public Overloads Overrides Function Equals(ByVal obj As Object) As Boolean
        Return MyBase.Equals(obj)
    End Function

#End Region

#Region "COM Registrierung"

    ' Name der Funktion spielt keine Rolle
    <ComRegisterFunction()> _
       Public Shared Sub RegisterClass(ByVal t As Type)
        ' GUID in HKLM\Software\Classes anlegen
        Dim Key As RegistryKey = Registry.ClassesRoot.CreateSubKey("CLSID\{" & _
            t.GUID.ToString().ToUpper() & "}")
        ' Für Excel-Automatisierung erforderlich
        Dim SubKey As RegistryKey = Key.CreateSubKey("Programmable")
        ' Standardwert setzen
        Key.SetValue("", "Excel.NET Functions")
        ' Standardwert auf Pfad von Mscoree.dll setzen
        Key.CreateSubKey("InprocServer32\").SetValue("", Environment.GetEnvironmentVariable("systemroot") & "\System32\Mscoree.dll")
        ' Schlüssel in HKLM\Software\Classes anlegen
        Key = Registry.ClassesRoot.CreateSubKey("ExcelNET.Functions")
        ' Standardwert setzen
        Key.SetValue("", "Peters Excel.NET-Funktionen")
    End Sub

#End Region

End Class
