﻿Imports VSTO = Microsoft.Office.Tools.Excel
Imports System.IO
Imports System.Reflection
Imports System.Runtime.InteropServices

Public Class Tabelle1

    Private Sub Tabelle1_Startup(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Startup
        Try
            Dim TmpPfadXsd As String = IO.Path.GetTempFileName
            Dim Ass As Assembly = Assembly.GetExecutingAssembly()
            Dim StQuelle As Stream = Ass.GetManifestResourceStream("VSTOListObjectBeispiel.Daten.xml")
            Dim XmlDaten As String
            Using SrZiel As New StreamReader(StQuelle)
                XmlDaten = SrZiel.ReadToEnd
            End Using
            ' Jetzt Schema lesen
            StQuelle = Ass.GetManifestResourceStream("VSTOListObjectBeispiel.Daten.xsd")
            Using SrZiel As New StreamReader(StQuelle)
                Using Sw As New StreamWriter(TmpPfadXsd)
                    Sw.Write(SrZiel.ReadToEnd)
                End Using
            End Using
            Dim XMap As Excel.XmlMap = Globals.ThisWorkbook.XmlMaps.Add(TmpPfadXsd, "Daten")
            'Dim XMap As Excel.XmlMap = Globals.ThisWorkbook.XmlMaps.Add(TmpPfadXsd, "Daten")
            'XMap.Name = "Daten_Zuordnung"
            Dim R As Excel.Range = Me.Application.Range("A1")
            If Globals.ThisWorkbook.XmlImportXml(Data:=XmlDaten, ImportMap:=XMap, Overwrite:=True, Destination:=R) = Excel.XlXmlImportResult.xlXmlImportSuccess Then

            Else
                Stop
            End If

            Dim Li As VSTO.ListObject = Globals.Tabelle1.Controls.AddListObject(R, "Daten")
            'Dim ExMp As Excel.XmlMap = Me.XmlMaps.Add("Daten")
            'Globals.ThisWorkbook.XmlImport(Url:=TmpPfad, ImportMap:=Nothing, Overwrite:=True, Destination:=R)
            'CType(Me.ActiveSheet, Excel.Worksheet).ListObjects(1).Name = "Daten"
        Catch Ex As COMException
            MessageBox.Show("COMException: " & Ex.Message)
        Catch Ex As SystemException
            MessageBox.Show("Exception: " & Ex.Message)
        End Try

    End Sub

    Private Sub Tabelle1_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown

    End Sub

End Class
