﻿Imports ZitategeberLib

Public Class ThisAddIn
    Private CbCn1 As Office.CommandBarButton

    Private Sub ThisAddIn_Startup(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Startup
        SetupCommandbar()
    End Sub

    Private Sub ThisAddIn_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown
        DeleteCommandBar()
    End Sub

    Sub SetupCommandbar()
        Dim CbNeu As Office.CommandBar = Me.Application.CommandBars.Add(Name:="Zitatgeber", Temporary:=True)
        With CbNeu
            .Visible = True
            CbCn1 = CbNeu.Controls.Add(Type:=Office.MsoControlType.msoControlButton, Temporary:=True)
            CbCn1.Tag = "Zitatgeber"
            CbCn1.FaceId = 59
            CbCn1.Caption = "Peters Zitatgeber für VSTO"
            CbCn1.Style = Microsoft.Office.Core.MsoButtonStyle.msoButtonIconAndCaption
        End With
        ' Jetzt Handler hinzufügen
        AddHandler CbCn1.Click, AddressOf CbCn1_ClickHandler
    End Sub

    Sub DeleteCommandBar()
        Try
            Dim Cb As Office.CommandBar = Me.Application.CommandBars.Item("Zitatgeber")
            Cb.Delete()
        Catch ex As SystemException
            ' Hier passiert nichts
        End Try
    End Sub

    Sub CbCn1_ClickHandler(ByVal Btn As Office.CommandBarButton, ByRef CancelDefault As Boolean)
        If Zitategeber.ShowForm() = DialogResult.OK Then
            Me.Application.Selection.TypeText(Zitategeber.Spruch)
            Me.Application.Selection.TypeParagraph()
            Me.Application.Selection.TypeText(Zitategeber.Quelle)
        End If
    End Sub

End Class
