﻿' -----------------------------------------------------------
' Office 2007-Programmierung, Microsoft Press
' Kopieren einer DataTable in ein Excel-Arbeitsblatt
' -----------------------------------------------------------

Public Class Tabelle1

    Private Sub Tabelle1_Startup(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Startup
        Dim DaEmp As New NwDsTableAdapters.EmployeesTableAdapter
        Dim TaEmp As NwDs.EmployeesDataTable = DaEmp.GetData
        CopyTaToSheet(TaEmp, Me.Range("A1"))
    End Sub

    Private Sub Tabelle1_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown
        '
    End Sub

    Sub CopyTaToSheet(ByVal Ta As DataTable, ByVal R As Excel.Range)
        If Ta Is Nothing Or Ta.Rows.Count = 0 Then
            Return
        End If
        Dim Zeile As Integer
        Dim Spalte As Integer
        'Dim Werte(Ta.Columns.Count - 1) As Object
        Zeile = R.Row
        ' Kopfzeile aufbauen
        For Spalte = 0 To Ta.Columns.Count - 1
            R.Cells(Zeile, Spalte + 1).Value = Ta.Columns(Spalte).ColumnName
        Next
        '  Jetzt jede Zeile durchgehen
        For Zeile = 0 To Ta.Rows.Count - 1
            For Spalte = 0 To Ta.Columns.Count - 1
                If TypeName(Ta.Rows(Zeile).Item(Spalte)) <> "Byte()" Then
                    R.Cells(Zeile + 2, Spalte + 1).Value = Ta.Rows(Zeile).Item(Spalte)
                End If
            Next
        Next
    End Sub

End Class
