﻿' Datenbindung an NamedRange-Objekten
Public Class Tabelle1
    Private Bs As BindingSource
    Private DaEmp As NwDsTableAdapters.EmployeesTableAdapter
    Private TaEmp As DataTable

    Private Sub Tabelle1_Startup(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Startup

        ' Datenbindung einrichten
        Bs = New BindingSource()
        DaEmp = New NwDsTableAdapters.EmployeesTableAdapter
        TaEmp = DaEmp.GetData
        Bs.DataSource = TaEmp
        Vorname.DataBindings.Add("Value2", Bs, "FirstName", False, DataSourceUpdateMode.OnPropertyChanged)
        Nachname.DataBindings.Add("Value2", Bs, "LastName", False, DataSourceUpdateMode.OnPropertyChanged)
        GebDatum.DataBindings.Add("Value2", Bs, "BirthDate", False, DataSourceUpdateMode.OnPropertyChanged)
        Stadt.DataBindings.Add("Value2", Bs, "City", True, DataSourceUpdateMode.OnPropertyChanged)
    End Sub

    Private Sub Tabelle1_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown
        ' 
    End Sub

    Private Sub bnNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnNext.Click
        Bs.MoveNext()
    End Sub

    Private Sub bnMovePrev_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles bnMovePrev.Click
        Bs.MovePrevious()
    End Sub

    Private Sub bnUpdate_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles bnUpdate.Click
        Dim Anzahl As Integer
        Anzahl = DaEmp.Update(TaEmp)
        MessageBox.Show(Anzahl & " Datensätze aktualisiert.")
    End Sub
End Class
