﻿' Beispiel für einen Timer, der eine Zelle blinken lässt
Public Class Tabelle1
    Private WithEvents ZeitGeber As Timer
    Private bModus As Boolean
    Private Spalte, Zeile, Farbe As Integer

    Private Sub Tabelle1_Startup(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Startup
        ZeitGeber = New Timer()
        ZeitGeber.Enabled = True
        ZeitGeber.Stop()
    End Sub

    Private Sub Tabelle1_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown
        ZeitGeber.Stop()
    End Sub

    Private Sub bnBlinkKontrolle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnBlinkKontrolle.Click
        If bModus Then
            ZeitGeber.Stop()
            bnBlinkKontrolle.Text = "&Start"
            bModus = False
        Else
            Spalte = New Random().Next(1, BlinkBereich.Columns.Count)
            Zeile = New Random().Next(1, BlinkBereich.Rows.Count)
            Farbe = New Random().Next(1, 16)
            Try
                ZeitGeber.Interval = Me.Range("Intervall").Value
            Catch ex As System.Runtime.InteropServices.COMException
                ZeitGeber.Interval = 1000
            End Try
            ZeitGeber.Start()
            bnBlinkKontrolle.Text = "&Stop"
            bModus = True
        End If
    End Sub

    Private Sub ZeitGeber_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles ZeitGeber.Tick
        Static OldColor As Integer
        Static Modus As Boolean
        Modus = Not Modus
        '        Try
        If Modus Then
            OldColor = CType(Me.Cells(Zeile, Spalte), Excel.Range).Interior.ColorIndex
            CType(Me.Cells(Zeile, Spalte), Excel.Range).Interior.ColorIndex = Farbe
        Else
            CType(Me.Cells(Zeile, Spalte), Excel.Range).Interior.ColorIndex = OldColor
        End If

        'Catch ex As System.Runtime.InteropServices.COMException
        'ZeitGeber.Stop()
        'End Try
    End Sub
End Class
