<?xml version="1.0" encoding="windows-1256" ?> 
<xsl:stylesheet   version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:template match="/" >
<html>
	<head>
		<style>
			table        	{ border-style: solid; border-width: medium}
			td     	{ border-style: solid; border-width: thin}
		</style>
	</head>
	<body>
		<h1 style="font-family:Arial;font-size:13pt">Unsere Workshops der Woche</h1>
		<table style="font-family:Arial;font-size:11pt" width="80%" align="center">
			<thead style="font-weight:bold">
				<td>Thema</td> 
				<td>Trainer</td>
				<td>Tag</td>
				<td>Uhrzeit</td> 
				<td>Level</td>
			</thead>
			<xsl:for-each select="workshops/workshop[@level=2]" order-by="trainer" >
				<tr>
					<td>
						<xsl:value-of select="thema" /> 
					</td>
					<td>
						<xsl:value-of select="trainer" /> 
					</td>
					<td>
						<xsl:value-of select="tag" /> 
					</td>
					<td>
						<xsl:value-of select="uhrzeit" /> 
					</td>
					<td>
						<xsl:value-of select="@level" /> 
					</td>
				</tr>
			</xsl:for-each>
		</table>
	</body>
</html>
</xsl:template>
</xsl:stylesheet>