﻿
Partial Class ThisAddIn
    Dim byXml As byXML

    Protected Overrides Function CreateRibbonExtensibilityObject() As Microsoft.Office.Core.IRibbonExtensibility
        byXml = New byXML
        Return byXml
    End Function
End Class


<Runtime.InteropServices.ComVisible(True)> _
    Public Class byXML
    Implements Office.IRibbonExtensibility

    Public myRibbon As Office.IRibbonUI

    Public Sub New()
    End Sub

    Public Function GetCustomUI(ByVal ribbonID As String) As String Implements Office.IRibbonExtensibility.GetCustomUI
        Return GetResourceText("customTaskPane.byXML.xml")
    End Function



#Region "Multifunktionsleisten-Rückrufe"
    'Erstellen Sie hier Rückrufmethoden. Weitere Informationen über das Hinzufügen von Rückrufmethoden erhalten Sie, indem Sie das Multifunktionsleisten-XML-Element im Projektmappen-Explorer markieren und dann F1 drücken.
    Public Sub Ribbon_Load(ByVal ribbonUI As Office.IRibbonUI)
        Me.myRibbon = ribbonUI
    End Sub

    Public Function getPressed(ByVal c As Office.IRibbonControl) As Boolean
        Return customTaskPane.Globals.ThisAddIn.ctp.Visible
    End Function

    Public Sub press(ByVal c As Office.IRibbonControl, ByVal pressed As Boolean)
        customTaskPane.Globals.ThisAddIn.ctp.Visible = pressed
    End Sub

    Public Function getImage(ByVal c As Office.IRibbonControl) As stdole.IPictureDisp
        Dim ax As New myAxHost
        Return ax.convert(My.Resources.buttonPic)
    End Function


#End Region

#Region "Helfer"

    Private Shared Function GetResourceText(ByVal resourceName As String) As String
        Dim asm As Reflection.Assembly = Reflection.Assembly.GetExecutingAssembly()
        Dim resourceNames() As String = asm.GetManifestResourceNames()
        For i As Integer = 0 To resourceNames.Length - 1
            If String.Compare(resourceName, resourceNames(i), StringComparison.OrdinalIgnoreCase) = 0 Then
                Using resourceReader As IO.StreamReader = New IO.StreamReader(asm.GetManifestResourceStream(resourceNames(i)))
                    If resourceReader IsNot Nothing Then
                        Return resourceReader.ReadToEnd()
                    End If
                End Using
            End If
        Next
        Return Nothing
    End Function

#End Region

End Class
