﻿Imports Microsoft.Office.Tools.Ribbon

Public Class Ribbon1

    Dim inspector As Office.DocumentInspector

    Private Sub Ribbon1_Load(ByVal sender As System.Object, ByVal e As RibbonUIEventArgs) Handles MyBase.Load

    End Sub

    Private Sub btnCheck_Click(ByVal sender As System.Object, ByVal e As Microsoft.Office.Tools.Ribbon.RibbonControlEventArgs) Handles btnCheck.Click
        Try
            Dim status As Microsoft.Office.Core.MsoDocInspectorStatus = Microsoft.Office.Core.MsoDocInspectorStatus.msoDocInspectorStatusDocOk
            Dim strResults As String = ""
            Me.ddSlides.Items.Clear()
            Me.ddSlides.Enabled = False
            For Each di As Microsoft.Office.Core.DocumentInspector In pptDocInspector.Globals.ThisAddIn.Application.ActivePresentation.DocumentInspectors
                If di.Name = "Layout-Inspector" Then
                    di.Inspect(status, strResults)
                    If status = Microsoft.Office.Core.MsoDocInspectorStatus.msoDocInspectorStatusIssueFound Then
                        Me.btnFix.Enabled = True
                        inspector = di
                    End If
                    Exit For
                End If
            Next
            If status = Microsoft.Office.Core.MsoDocInspectorStatus.msoDocInspectorStatusDocOk Then
                MsgBox("Alle Folien sind korrekt oder ausgeblendet.")
            Else
                MsgBox("Es gibt nicht korrekte Folien.")
            End If
        Catch ex As Exception

        End Try
    End Sub

    Private Sub btnFix_Click(ByVal sender As Object, ByVal e As Microsoft.Office.Tools.Ribbon.RibbonControlEventArgs) Handles btnFix.Click
        Me.ddSlides.Enabled = True
        Try
            inspector.Fix(Microsoft.Office.Core.MsoDocInspectorStatus.msoDocInspectorStatusDocOk, "Folien mit nicht korrektem Layout wurden u. U. ausgeblendet.")
        Catch ex As Exception
            MsgBox("Fehler")
        End Try
        Me.btnFix.Enabled = False
    End Sub

    Private Sub ddSlides_ButtonClick(ByVal sender As Object, ByVal e As Microsoft.Office.Tools.Ribbon.RibbonControlEventArgs) Handles ddSlides.ButtonClick

    End Sub

End Class
