﻿Public Class showCustomXml
    Private mActiveWorkbook As Excel.Workbook
    Public WriteOnly Property activeWorkbook() As Excel.Workbook
        Set(ByVal value As Excel.Workbook)
            mActiveWorkbook = value
        End Set
    End Property

    Private Sub showCustomXml_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            Dim custom As Office.CustomXMLPart
            ComboBox1.Items.Clear()
            For Each custom In mActiveWorkbook.CustomXMLParts
                ComboBox1.Items.Add(custom.NamespaceURI)
            Next
            If ComboBox1.Items.Count > 0 Then
                ComboBox1.SelectedIndex = ComboBox1.Items.Count - 1
            End If
        Catch ex As Exception

        End Try
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        Try
            Dim custom As Office.CustomXMLPart
            custom = mActiveWorkbook.CustomXMLParts(ComboBox1.SelectedIndex + 1)
            Dim s As IO.StreamWriter = New IO.StreamWriter("c:\temp.xml")
            s.Write(custom.XML)
            s.Close()
            WebBrowser1.Navigate("c:\temp.xml")
        Catch ex As Exception

        End Try
    End Sub

    Private Sub btnRemove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRemove.Click
        If ComboBox1.SelectedIndex > -1 Then
            Try
                Dim custom As Office.CustomXMLPart
                custom = mActiveWorkbook.CustomXMLParts.Item(ComboBox1.SelectedIndex + 1)
                custom.Delete()
                ComboBox1.Items.RemoveAt(ComboBox1.SelectedIndex)
                'ComboBox1.Items.Clear()
                'ComboBox1.Text = ""
                'For Each custom In mActiveWorkbook.CustomXMLParts
                '    ComboBox1.Items.Add(custom.NamespaceURI)
                'Next
                WebBrowser1.Navigate("about:blank")
            Catch ex As Exception
                MsgBox(Err.Description)
            End Try
        End If
    End Sub
End Class
