﻿Public Class schemaReferences

    Private mActiveDocument As Word.Document

    Public WriteOnly Property activeDocument() As Word.Document
        Set(ByVal value As Word.Document)
            mActiveDocument = value
        End Set
    End Property

    Private Sub schemaReferences_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            Dim ref As Word.XMLSchemaReference
            For Each ref In mActiveDocument.XMLSchemaReferences
                ComboBox1.Items.Add(ref.NamespaceURI)
            Next
            If ComboBox1.Items.Count > 0 Then
                btnReload.Visible = True
                ComboBox1.SelectedIndex = 0
            Else
                btnReload.Visible = False
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        Try
            Dim ref As Word.XMLSchemaReference = mActiveDocument.XMLSchemaReferences(ComboBox1.SelectedIndex + 1)
            lblURL.Text = ref.Location
            WebBrowser1.Navigate(ref.Location)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub btnReload_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReload.Click
        Try
            Dim ref As Word.XMLSchemaReference = mActiveDocument.XMLSchemaReferences(ComboBox1.SelectedIndex + 1)
            ref.Reload()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub
End Class
