﻿Public Class showCustomXml
    Private mActiveDocument As Word.Document
    Private mFileToOpen As String

    Public WriteOnly Property activeDocument() As Word.Document
        Set(ByVal value As Word.Document)
            mActiveDocument = value
        End Set
    End Property

    Public WriteOnly Property fileToOpen() As String
        Set(ByVal value As String)
            mFileToOpen = value
        End Set
    End Property

    Private Sub showCustomXml_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            ComboBox1.Items.Clear()
            For Each custom As Office.CustomXMLPart In mActiveDocument.CustomXMLParts
                ComboBox1.Items.Add(custom.NamespaceURI)
            Next
            If ComboBox1.Items.Count > 0 Then
                ComboBox1.SelectedIndex = 0
            End If
        Catch ex As Exception

        End Try
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        Try
            Dim custom As Office.CustomXMLPart = mActiveDocument.CustomXMLParts(ComboBox1.SelectedIndex + 1)
            Dim sw As IO.StreamWriter = New IO.StreamWriter(mFileToOpen)
            sw.Write(custom.XML)
            sw.Close()
            WebBrowser1.Navigate(mFileToOpen)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub btnRemove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRemove.Click
        If ComboBox1.SelectedIndex > -1 Then
            Try
                mActiveDocument.CustomXMLParts.Item(ComboBox1.SelectedIndex + 1).Delete()
                ComboBox1.Items.Clear()
                ComboBox1.Text = ""
                For Each custom As Office.CustomXMLPart In mActiveDocument.CustomXMLParts
                    ComboBox1.Items.Add(custom.NamespaceURI)
                Next
                WebBrowser1.Navigate("about:blank")
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        End If
    End Sub
End Class
