﻿Imports Microsoft.Office.Tools.Ribbon

Public Class Ribbon1

    Dim WithEvents myWebservice As localhost.Products

    Private Sub Ribbon1_Load(ByVal sender As System.Object, ByVal e As RibbonUIEventArgs) Handles MyBase.Load

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As Microsoft.Office.Tools.Ribbon.RibbonControlEventArgs) Handles Button1.Click
        'erster Test
        ''Web Reference
        'Dim wr As New localhost.Products
        'MsgBox(wr.GetActualData.xmlInfo.GetXml)

        ''Service Reference
        'Dim sr As New ServiceReference1.ProductsSoapClient
        'MsgBox(sr.GetActualData.xmlInfo.GetXml)

        'asynchroner Aufruf
        myWebservice = New localhost.Products
        myWebservice.GetActualDataAsync()

    End Sub

    Private Sub myWebservice_GetActualDataCompleted(ByVal sender As Object, ByVal e As localhost.GetActualDataCompletedEventArgs) Handles myWebservice.GetActualDataCompleted
        Try
            Dim xmlDoc As New Xml.XmlDocument
            xmlDoc.LoadXml(e.Result.xmlInfo.GetXml)

            Dim xmlStyleSheet As New Xml.XmlDocument
            xmlStyleSheet.LoadXml(My.Resources.northwind)
            Dim readerStyleSheet As Xml.XmlReader = Xml.XmlReader.Create(New System.IO.StringReader(xmlStyleSheet.OuterXml))

            Dim xmlTrans As New Xml.Xsl.XslCompiledTransform
            xmlTrans.Load(readerStyleSheet)

            Dim transformedData As New StringBuilder
            Dim xmlWriter As Xml.XmlWriter = Xml.XmlWriter.Create(transformedData)
            xmlTrans.Transform(xmlDoc, xmlWriter)

            Dim wsh As Excel.Worksheet
            wsh = NorthwindClient.Globals.ThisWorkbook.Worksheets.Add
            Dim rng As Excel.Range
            rng = wsh.Range("A1:C" & e.Result.intRecords.ToString)
            rng.Value(Excel.XlRangeValueDataType.xlRangeValueXMLSpreadsheet) = transformedData.ToString
            rng.EntireColumn.AutoFit()
        Catch ex As Exception

        End Try
    End Sub

  
End Class
