﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns:user="http://dev2007/webservice/dsProducts.xsd">
  <xsl:template match="/">
    <Workbook xmlns="urn:schemas-microsoft-com:office:spreadsheet"
       xmlns:o="urn:schemas-microsoft-com:office:office"
       xmlns:x="urn:schemas-microsoft-com:office:excel"
       xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet"
       xmlns:html="http://www.w3.org/TR/REC-html40">
      <Styles>
        <Style ss:ID="Default" ss:Name="Normal">
          <Alignment ss:Vertical="Bottom" />
        </Style>
      </Styles>
      <Worksheet ss:Name="Northwind">
        <Table ss:DefaultColumnWidth="60">
          <Row>
            <Cell>
              <Data ss:Type="String">Nr.</Data>
            </Cell>
            <Cell>
              <Data ss:Type="String">Artikel</Data>
            </Cell>
            <Cell>
              <Data ss:Type="String">Kategorie</Data>
            </Cell>
          </Row>
          <xsl:for-each select="user:dsProducts/user:MyProducts">
            <Row>
              <Cell>
                <Data ss:Type="Number">
                  <xsl:value-of select="user:ProductID" />
                </Data>
              </Cell>
              <Cell>
                <Data ss:Type="String">
                  <xsl:value-of select="user:ProductName" />
                </Data>
              </Cell>
              <Cell>
                <Data ss:Type="String">
                  <xsl:value-of select="user:CategoryName" />
                </Data>
              </Cell>
            </Row>
          </xsl:for-each>
        </Table>
      </Worksheet>
    </Workbook>
  </xsl:template>
</xsl:stylesheet>

